<?php
// -----------------------------------------------
//  Rotinas Genericas
// -----------------------------------------------
function dinheiro($valor,$branco=0)
{
   //return sprintf("%01.2f", $valor);  BR
   if ($branco==1 and $valor==0)
      return '';

   return number_format($valor,2,',','.');
}

function servertime($con) // retorna a hora do servidor
{
 $res = bd_consulta ($con, 'select getdate() ');
 $reg = bd_proximo ($res);
 return $reg[0];
}

 function datediff($interval, $datefrom, $dateto, $using_timestamps = true) {
 /*
 $interval can be:
 yyyy - Number of full years
 q - Number of full quarters
 m - Number of full months
 y - Difference between day numbers
 (eg 1st Jan 2004 is "1", the first day. 2nd Feb 2003 is "33". The datediff is "-32".)
 d - Number of full days
 w - Number of full weekdays
 ww - Number of full weeks
 h - Number of full hours
 n - Number of full minutes
 s - Number of full seconds (default)
 */

 if (!$using_timestamps) {
    $datefrom = strtotime($datefrom, 0);
    $dateto = strtotime($dateto, 0);
 }
 $difference = $dateto - $datefrom; // Difference in seconds

 switch($interval) {

 case 'yyyy': // Number of full years

 $years_difference = floor($difference / 31536000);
 if (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom), date("j", $datefrom), date("Y", $datefrom)+$years_difference) > $dateto) {
 $years_difference--;
 }
 if (mktime(date("H", $dateto), date("i", $dateto), date("s", $dateto), date("n", $dateto), date("j", $dateto), date("Y", $dateto)-($years_difference+1)) > $datefrom) {
 $years_difference++;
 }
 $datediff = $years_difference;
 break;

 case "q": // Number of full quarters

 $quarters_difference = floor($difference / 8035200);
 while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom)+($quarters_difference*3), date("j", $dateto), date("Y", $datefrom)) < $dateto) {
 $months_difference++;
 }
 $quarters_difference--;
 $datediff = $quarters_difference;
 break;

 case "m": // Number of full months

 $months_difference = floor($difference / 2678400);
 while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom)+($months_difference), date("j", $dateto), date("Y", $datefrom)) < $dateto) {
 $months_difference++;
 }
 $months_difference--;
 $datediff = $months_difference;
 break;

 case 'y': // Difference between day numbers

 $datediff = date("z", $dateto) - date("z", $datefrom);
 break;

 case "d": // Number of full days

 $datediff = floor($difference / 86400);
 break;

 case "w": // Number of full weekdays

 $days_difference = floor($difference / 86400);
 $weeks_difference = floor($days_difference / 7); // Complete weeks
 $first_day = date("w", $datefrom);
 $days_remainder = floor($days_difference % 7);
 $odd_days = $first_day + $days_remainder; // Do we have a Saturday or Sunday in the remainder?
 if ($odd_days > 7) { // Sunday
 $days_remainder--;
 }
 if ($odd_days > 6) { // Saturday
 $days_remainder--;
 }
 $datediff = ($weeks_difference * 5) + $days_remainder;
 break;

 case "ww": // Number of full weeks

 $datediff = floor($difference / 604800);
 break;

 case "h": // Number of full hours

 $datediff = floor($difference / 3600);
 break;

 case "n": // Number of full minutes

 $datediff = floor($difference / 60);
 break;

 default: // Number of full seconds (default)

 $datediff = $difference;
 break;
 }

 return $datediff;
 }


function DateAdd($interval, $number, $date) {
/*
Interval can be one of:
yyyy	year
q	Quarter
m	Month
y	Day of year
d	Day
w	Weekday
ww	Week of year
h	Hour
n	Minute
s	Second
*/
    $date_time_array = getdate($date);
    $hours = $date_time_array['hours'];
    $minutes = $date_time_array['minutes'];
    $seconds = $date_time_array['seconds'];
    $month = $date_time_array['mon'];
    $day = $date_time_array['mday'];
    $year = $date_time_array['year'];

    switch ($interval) {

        case 'yyyy':
            $year+=$number;
            break;
        case 'q':
            $year+=($number*3);
            break;
        case 'm':
            $month+=$number;
            break;
        //case 'y':
        case 'd':
            $day+=$number;
            break;
        //case 'w':
            
        case 'ww':
            $day+=($number*7);
            break;
        case 'h':
            $hours+=$number;
            break;
        case 'n':
            $minutes+=$number;
            break;
        case 's':
            $seconds+=$number;
            break;
    }
       $timestamp= mktime($hours,$minutes,$seconds,$month,$day,$year);
    return $timestamp;
}

function Unix2ISO($ux) {
  // converte datahora UNIX para ISO
  return date("Y-m-d H:i:s",$ux);
}

function Unix2SQL($ux) {
  return date("Y-m-d H:i:s",$ux);
}

function left($txt,$n) {
  return substr($txt,0,$n);
}

function cproper($texto){
  $rc=ucwords( strtolower( no_acent( rtrim( $texto ) ) ));
  $rc=str_replace(" E "," e ",$rc);
  $rc=str_replace(" De "," de ",$rc);
  $rc=str_replace(" Com "," com ",$rc);

  return $rc;
}


function no_acent($Msg)
{
  $var=$Msg;
  $var = ereg_replace("[]","A",$var);
  $var = ereg_replace("[]","a",$var);
  $var = ereg_replace("[]","E",$var);
  $var = ereg_replace("[]","I",$var);
  $var = ereg_replace("[]","i",$var);
  $var = ereg_replace("[]","e",$var);
  $var = ereg_replace("[]","O",$var);
  $var = ereg_replace("[]","o",$var);
  $var = ereg_replace("[]","U",$var);
  $var = ereg_replace("[]","u",$var);
  $var = str_replace("","C",$var);
  $var = str_replace("","c",$var);
  $var = str_replace(""," ",$var);

  // Tira o acento pela chave do array
  return $var;
 }


function flat2Unix($_dt){
   $_ano=substr($_dt,0,4);
   $_mes=substr($_dt,4,2);
   $_dia=substr($_dt,6,2);
   $_hr =0;//substr($_dt,11,2);
   $_mn =0;//substr($_dt,14,2);
   $_sc =0;

   return mktime($_hr,$_mn,$_sc,$_mes,$_dia,$_ano) ;
}

function ISO2Unix($_dt,$semsegundo=true)
{
  // converte datahora no formato ISO para o Formato UNIX
  
   $_ano=substr($_dt,0,4);
   $_mes=substr($_dt,5,2);
   $_dia=substr($_dt,8,2);
   $_hr =substr($_dt,11,2);
   $_mn =substr($_dt,14,2);
   if ($semsegundo)
     $_sc=0;
   else
     $_sc=substr($_dt,17,2);
     
   return mktime($_hr,$_mn,$_sc,$_mes,$_dia,$_ano) ;
}


function addTz($dt,$TZ)
{
   // recebe data no formato ISO e adiciona o Timezone
   $ano=substr($dt,0,4);
   $mes=substr($dt,5,2);
   $dia=substr($dt,8,2);
   $hr =substr($dt,11,2);
   $mn =substr($dt,14,2);

   $dunix=mktime($hr,$mn,0,$mes,$dia,$ano) - ($TZ*60);
   return date("Y-m-d H:i" ,$dunix );
}

function ISO2tc($dt)
{
  // converte datetime no formato ISO para Hora no formato caracter
   $ano=substr($dt,0,4);
   $mes=substr($dt,5,2);
   $dia=substr($dt,8,2);
   $hr =substr($dt,11,2);
   $mn =substr($dt,14,2);
   $sc =substr($dt,17,2);
   return $hr.':'.$mn .':'.$sc;
}


#-------------------------------------------------------------------------------
// ordenao de matriz descendente
function comparedesc ($x, $y)
{
 if ( $x[1] == $y[1] )
    return 0;
 else if ( $x[1] < $y[1] )
    return 1;
 else
    return -1;
}
#-------------------------------------------------------------------------------

function trunc4($valor)
{
   //return floor($valor * 1000000)/1000000;          // NELSON
   return round($valor , 7);                       // SILVIO
}

function trunc5($valor)
{                                                   // 10 Abr 07 ( 5 Decimais )
   return floor($valor * 1000000)/1000000;          // NELSON & Silvio
}

function trunc44($valor)
{
   return floor($valor * 10000)/10000;          // NELSON
}


function trunc8($valor)
{
   $x=floor($valor * 100000000)/100000000;          // NELSON
   return number_format( $x,8,'.',',');
}


function americano($valor)
{
   return str_replace(',','', $valor);
}


function dtoc($data,$pt=false)
{
   // converte data no formato ISO para data caracter
   $dia=substr($data,8,2);
   $mes=substr($data,5,2);
   $ret=(TDZ=='PT' or $pt)?
        ($dia.'/'.$mes.'/'.substr($data,0,4)):($mes.'/'.$dia.'/'.substr($data,0,4));
   return $ret;
}

function dt($dt,$ano=0,$hora=0,$mdh=0)
{
   // converte data no formato ISO para data caracter
   $dthora=ISO2Unix($dt);
   if ($ano and $hora) {  // com ano e hora
     $ret =date("M j, Y",$dthora) . " at " . date("g:i a",$dthora);
   } elseif ($ano) {      // com ano
     $ret =date("M j, Y",$dthora);
   } elseif ($mdh) {      // com mes, dia e hora
     $ret =date("M j",$dthora) . " at " . date("g:i a",$hora);
   } else {               // so mes e dia
     $ret =date("M j",$dthora);
   }
   return $ret;
}

function dthora($dt,$semsegundo=0,$pt=false)
{
   // data e hora recebida
   if (TDZ=='PT' or $pt) {
     // portugues
     $hora= ($semsegundo==0) ? (substr($dt,11)) : (substr($dt,11,5));
     $ret=(TDZ=='PT' or $pt)?(dtoc($dt,$pt) . " s " . $hora):(dtoc($dt) . " at " . $hora);
   } else {
     // americano
     $hora=ISO2Unix($dt,$semsegundo);
     if ($semsegundo==0)
       $ret =date("n/j/Y",$hora) . " at " . date("g:i a",$hora);
     else
       $ret =date("n/j/Y",$hora) . " at " . date("g:i:s a",$hora);
   };
   return $ret;
}

function datahora()
{
  // data e hora atual
  If (TDZ=='PT') {
     $ret = (date("d/m/Y") . " s " . date("H:i:s"));      ###  Portugues
  }else{
	 ################## verificar -- mudar hora 24 para hora 12 com am/pm
#	 $h=intval(date("H"));
#	 $hora=($h>12)?($h-12):($h);
#    $ret = (date("m/d/Y") . " at $hora" . date(":i:s a"));    ###  Ingles
###########  (ANTERIOR)   $ret = (date("n/j/Y") . " at " . date("g:i:s a"));    ###  Ingles
     $ret = (date("M j, Y") . " at " . date("g:i:s a"));    ###  Americano
  }
  return $ret;
}

function perc($v1,$v2)  // percentual formatado com , e .
{
  // percentual entre dois valores
  if ($v2==0) {       # para evitar divisao por 0
     return 0;        # retorna 0
  } else {
     return number_format( ($v1/$v2)*100,2,'.',',');
  }
}

function perc0($v1,$v2)
{
  // percentual entre dois valores
  if ($v2==0) {       # para evitar divisao por 0
     return 0;        # retorna 0
  } else {
     return round(($v1/$v2)*100,2);
  }
}

function botao_ok($titulo,$msg,$local,$modo=0)
{
   if (!strpos($local,'?SD'))
     $local=$local . '?SD='. session_id();
     
   include("botao_ok.inc");
}



/*
function sqlerro($sql)
{
   $Sqlerro_num=mysql_errno();
   $Sqlerro_des=mysql_error();
   $Sqlerro = "(".$Sqlerro_num.") = ".$Sqlerro_des;
   $Ip=$_SERVER['REMOTE_ADDR'];  // Ip
   $Script=$_SERVER['PHP_SELF']; // script executado
   
   $La=$_SERVER['argv'];         // lista de argumentos

   if (  count($La) > 0  )
      $Sc_arg=$La[0];          // os argumentos
   else
      $Sc_arg="";               // os argumentos

   global $sessao;
   
   $comando="SQL ERRO: $Sqlerro_num = [ $Ip ]<br>$Script<br>$Sc_arg<br>$sql";
   $comando=str_replace("'",'',$comando);
   gravalog("*ERRO",$comando); //com sql

#   gravalog("*ERRO","SQL ERRO: $Sqlerro_num = [ $Ip ]<br>$Script<br>$Sc_arg"); //sem sql
   if (mysql_errno()==1062) {            # Erros com Tratamento
      alert('Chave Duplicada - No Gravado !!!');
      alert( $Sqlerro );
   ######### 1064 = Erro de Sintaxe...
   } else {                              # Erros sem Tratamento
     // encerra a tela com erro de SQL

     //if ($sessao->acesso==1 or $sessao->acesso==7) {
        echo $sql;
        echo 'SQL ERRO: ' . $Sqlerro ;
        
     //} else {
     //   trace('Ocorreu um erro do Banco de Dados SQL. Contate Suporte');
     //};

     //session_unregister("sid");
     exit(-1);
   };
}
*/

function money($valor,$branco=0)
{
   //return sprintf("%01.2f", $valor);
   if ($branco==1 and $valor==0)
      return '';

   return number_format($valor,2,'.',',');
}

function limpa_zeros($v){
  // retira zeros a direita
  while (substr($v,strlen($v)-1,1)=="0" ) {
    $v=substr($v,0,strlen($v)-1);

    if ( substr($v,strlen($v)-1,1)=="." ) {
      $v=substr($v,0,strlen($v)-1);
      break;
    };
  }
  if ($v==''){
    $v='0';
  }
  return $v;
}


function cotacao($valor,$branco=0)
{
   // est em formato americano...
   if ($branco==1 and $valor==0)
      return '';

   //return sprintf("%01.2f", $valor);
   return number_format(trunc5($valor),5,'.',',');
}


function inteiro($valor,$branco=0)
{
   // formatacao para inteiros-BR
   if ($branco==1 and $valor==0)
      return '';
      
   return number_format($valor,0,',','.');
}


function alert($texto)
{
   liserr($texto,'','');
}

function ft_lday($data)
{
   // coloca data no ultimo dia do mes

   $ano=intval(substr($data,0,4));
   $mes=intval(substr($data,5,2));
   $dia=32;
   while (! checkdate($mes,$dia,$ano ) ) {
     --$dia;
   };
   return isodate($dia,$mes,$ano);
}

function isodate( $day , $month , $year )
{
   // converte para data SQL
   if (!checkdate($month,$day,$year)){
      $day=0;
      $month=0;
      $year =0;
   };
   return sprintf("%04d-%02d-%02d", $year, $month, $day);
}

function isodatetime($day,$month,$year,$hora,$minu)
{
 return isodate($day,$month,$year).' '.sprintf("%02d:%02d", $hora, $minu);
}


function valid_email($address)
{
  // check an email address is possibly valid
  if (ereg("^[a-zA-Z0-9_\.\-]+@[a-zA-Z0-9\-]+\.[a-zA-Z0-9\-\.]+$", $address))
    return true;
  else
    return false;
}


function mensagem ()
{
  global $msg;
  return $msg ; //$oinv->msg ;
}


function edidata($dt,$indice,$fx1=0,$fx2=0)
{
   if ($fx2==0) {
      $fx2=date("Y")-18 ;
   };
   if ($fx1==0) {
      $fx1=date("Y")-80 ;
   };
   // apresenta data de edicao no formato
   $vano=substr($dt,0,4);
   $vmes=substr($dt,5,2);
   $vdia=substr($dt,8,2);
   
   $nano='ANO'.$indice;
   $nmes='MES'.$indice;
   $ndia='DIA'.$indice;
   
   if (TDZ=='PT') {
     $Tdia='Dia'; $Tmes='Ms'; $Tano='Ano';
   } else {
     $Tdia='Day'; $Tmes='Month'; $Tano='Year';
   };
   
   $txt_dia="<select size='1' name='$ndia'>".
   "<option VALUE='00'>$Tdia</option> \n";
   
   for ($i = 1; $i <= 31; $i++) {
     $bb=($i==$vdia) ? (' SELECTED ') : ('');
     $bx=sprintf("%02d",$i);
     $txt_dia=$txt_dia . "<option VALUE='$bx' $bb>$bx</option> \n";
   };
   $txt_dia=$txt_dia."</select> \n";


   $txt_mes="<select size='1' name='$nmes'> \n".
   "<option VALUE='00'>$Tmes</option> \n";
   for ($i = 1; $i <= 12; $i++) {
     $bb=($i==$vmes) ? (' SELECTED ') : ('');
     $bx=sprintf("%02d",$i);
     $txt_mes=$txt_mes . "<option VALUE='$bx' $bb>$bx</option> \n";
   };
   $txt_mes=$txt_mes."</select> \n";

   $txt_ano="<select size='1' name='$nano'> \n".
   "<option VALUE='000'>$Tano</option> \n";
   for ($i = $fx1; $i <= $fx2; $i++) {
     $bb=($i==$vano) ? (' SELECTED ') : ('');
     $bx=sprintf("%04d",$i);
     $txt_ano=$txt_ano . "<option VALUE='$bx' $bb>$bx</option>";
   };
   $txt_ano=$txt_ano."</select> \n";

   //$txt_ano="<input type='text' name='$nano' value='$vano' size='7' maxlength='4' >";


   return $txt_dia."/&nbsp;".$txt_mes."/&nbsp;".$txt_ano;
}


function edihora($hr , $indice, $reduzido=0)
{
   if ($reduzido==0) {
      $maxfor=59;
   } else {
      $maxfor=55;
   }
   
   $hora=substr($hr,0,2);
   $minu=substr($hr,3,2);

   $nhora='HORA'.$indice;
   $nminu='MINU'.$indice;

   // horas
   $txt_dia="<select size='1' name='$nhora'>";
   for ($i = 0; $i <= 23; $i++) {
     $bb=($i==$hora) ? (' SELECTED ') : ('');
     $bx=sprintf("%02d",$i);
     $txt_dia=$txt_dia . "<option VALUE='$bx' $bb>$bx</option> \n";
   };
   $txt_dia=$txt_dia."</select> \n";

   // minutos
   $txt_mes="<select size='1' name='$nminu'> \n";
   for ($i = 0; $i <= $maxfor; (($reduzido==0)?($i++):($i+=5)) ) {
     $bb=($i==$minu) ? (' SELECTED ') : ('');
     $bx=sprintf("%02d",$i);
     $txt_mes=$txt_mes . "<option VALUE='$bx' $bb>$bx</option> \n";
   };
   $txt_mes=$txt_mes."</select> \n";

   return $txt_dia.":&nbsp;".$txt_mes;
}

function edidatahora($tx,$indice)
{
   $txdata=substr($tx,0 ,10);
   $txhora=substr($tx,11,5);
   $fx1=date("Y")-2; // (2001) em 2003
   $fx2=date("Y")+3; // (2006) em 2003
   return edidata($txdata,$indice,$fx1,$fx2).' As '.edihora($txhora,$indice);
}

function EditSimNao($tx,$valor)
{
   $txdata  ='<select name="' .$tx .'" size="1">';
   $txdata .= '<option value="S" ' .(($valor=='S')?('SELECTED'):('')) . '>Sim</option>';
   $txdata .= '<option value="N" ' .(($valor=='N')?('SELECTED'):('')) . '>No</option>';
   $txdata .= '</select>';

   return $txdata;
}


function display_button($target, $image, $alt)
{
  return "<a href=\"$target\" type=submit ><img src=\"$image\"  alt=\"$alt\" border=0 height = 28 width = 95></a>";
}


function btn_submit($texto)
{
  //return "<input type='submit' name='btnfuncao' value='$texto'>";
  //return "<BUTTON TYPE=submit NAME=btnfuncao ACCESSKEY=M>$texto</BUTTON>";
  return "<BUTTON TYPE=submit NAME=btnfuncao ACCESSKEY=M>$texto</BUTTON>";
}






function dump_array($array)
{
  if(is_array($array))
  {
    $size = count($array);
    $string = "";
    if($size)
    {
      $count = 0;
      $string .= "{ ";
      // add each element's key and value to the string
      foreach($array as $var => $value)
      {
        $string .= "$var = '$value'";
        if($count++ < ($size-1))
        {
          $string .= ", ";
        }
      }
      $string .= " }";
    }
    return $string;
  }
  else
  {
    // if it is not an array, just return it
    return $array;
  }
}

function diverse_array($vector) {
    $result = array();
    foreach($vector as $key1 => $value1)
        foreach($value1 as $key2 => $value2)
            $result[$key2][$key1] = $value2;
    return $result;
}




  function ajupar($strcampo, $strdefaul)
  {
  // # ----------- ajusta paramentros -----------

   $strcampo = (($strcampo) || ($strcampo != NULL)) ? $strcampo : $strdefaul;
   $strcampo = strtolower($strcampo);
   return $strcampo;
  }


  //=================== converte formato date em texto ***********************   
  function dattex($strcampo) {
     if (substr($strcampo, 4, 2) == "00") {
		   $strsaida = "";
	  }
	  else {
	      $strsaida = substr($strcampo, 6, 2) . "/" . substr($strcampo, 4, 2) . "/" . substr($strcampo, 0, 4) ;
	  }
	  return $strsaida;
  }






Function select_opt($string, $values,  $delimiter) {
 global $options;
 $options = seppar($string, $delimiter, "");
 $values = seppar($values, $delimiter, "");
 $itotopt = count($options);
 for( $i = 0; $i < $itotopt; $i++ ) {
    if ($options[$i]) echo "<option value=$values[$i]> $options[$i]\n";
 }

}


function msg($texto)
{
  if ( ! $texto=='' ) {
  echo " <SCRIPT FOR=window EVENT=onload LANGUAGE='JavaScript'>";
//  echo "    writeMenus();   ";   DESCOBERTO PELO RICARDO
  echo "    alert('$texto');";
  echo " </SCRIPT>";
  };
}


function gravalog($acao,$texto)
{
  // grava log de operaes
 global $sessao,$con ;

 /*
 $sql="INSERT INTO logadm (idinvestidor, datahora, idtorneio, acao, texto)
       VALUES ($sessao->idinvestidor, now(), {$sessao->torneio}, '$acao', '$texto') ;";

  $rc=bd_executa ($con, $sql);
  if ( ! $rc ) {
      sqlerro($sql);
  };
 */

}

function liserr($strmsgerr, $strmensag, $strmostra)
  {
  //======== lista os erros, limitado a 95 caracteres senao dah erro
  $strmostra = (($strmostra) || ($strmostra != NULL)) ? $strmostra : "N";
  $strmostra = strtoupper($strmostra);
  $strsepara = ($strmensag) ? (": ") : ("");
  if (($strmsgerr) || ($strmostra == "S"))
    {
      ?>
      <script language="javascript">
              window.alert("<? echo $strmensag . $strsepara . $strmsgerr; ?>");
      </script>
      <?
    }
  }

function calc_rio( $p_fim, $fator, $aliq1, $aliq2, $_modo_calc_ST, $_pauta, $_BST, $_perc_reduc)
{

//=* aliq1 = aliquota interna
//=* aliq2 = aliquota interestadual



if ($_perc_reduc==0)
  $pr=1; 
else
  $pr=1 - ($_perc_reduc/100);

    
   

$fixo=($_BST * $fator)  * $aliq2;
   
   
$rc=TRUNC(     ($p_fim-$fixo) / (1 - ($aliq1 * $pr))     );



if ($rc < 0 )
  return $p_fim;
else
  return $rc;

}




?>
